package checkers.igj;

import checkers.igj.quals.*;
import checkers.quals.SubtypeOf;
import checkers.quals.TypeQualifier;

/**
 * An annotation used to represent a place holder immutability type, that is a
 * subtype of all other types. For example, {@code null} type is a subtype
 * of all immutability types.
 *
 * However, it is an implementation detail; hence, the package-scope.
 */
@TypeQualifier
@SubtypeOf({Mutable.class, Immutable.class, AssignsFields.class, ReadOnly.class, I.class})
@interface IGJPlaceHolder {

}
