import checkers.interning.quals.*;

public class Polymorphism {
    // Test parameter
    public @PolyInterned String identity(@PolyInterned String s) {
        return s;
    }
    
    void testParam() {
        String notInterned = new String("not interned");
        @Interned String interned = "interned";
        
        interned = identity(interned);
        interned = identity(notInterned); // invalid
    }
    
    // test as receiver
    @PolyInterned Polymorphism getSelf() @PolyInterned {
        return this;
    }
    
    void testReceiver() {
        Polymorphism notInterned = new Polymorphism();
        @Interned Polymorphism interned = null;
        
        interned = interned.getSelf();
        interned = notInterned.getSelf(); // invalid
    }
}
